// --- bier tap ---
#declare surtidor=
union{
 // base
 cylinder{
  <0,0,0>
  <0,2,0>
  10
  texture{t_bs_metal}
 }
 // low ceramic tube part
 #declare puntos=20;      // y resolution
 #declare radio_cand=9;   // mean radius
 #declare alto_cand=24;   // y size
 #declare cnt_pto=1;
 #declare alt_act=0;
 #declare r_cand=seed(17);
 #declare a_surt1=array[puntos]
 #declare a_surt1[0]=<0,0,0>;
 #while (cnt_pto<(puntos-1))
  #declare a_surt1[cnt_pto]=<abs(radio_cand*.5+radio_cand*.5*rand(r_cand)),alto_cand*cnt_pto/puntos,0>;
  #declare cnt_pto=cnt_pto+1;
 #end
 #declare a_surt1[puntos-2]=<5,alto_cand,0>;
 #declare a_surt1[puntos-1]=<5,alto_cand,0>;
 object{meshlathe(a_surt1,.3,9)
  texture{t_bs_ceram}
 }
 // central metal tube
 union{
  cylinder{
   <0,24,0>
   <0,33,0>
   5
  }
  torus{5.1,.2 translate 24*y}
  torus{5.1,.2 translate 33*y}
  texture{t_bs_metal}
 }
 // upper ceramic tube part
 #declare puntos=9;      // y resolution
 #declare radio_cand=6;   // mean radius
 #declare alto_cand=6;   // y size
 #declare cnt_pto=2;
 #declare alt_act=0;
 #declare r_cand=seed(91);
 #declare a_surt2=array[puntos]
 #declare a_surt2[0]=<0,0,0>;
 #declare a_surt2[1]=<radio_cand,0,0>;
 #while (cnt_pto<puntos-1)
  #declare a_surt2[cnt_pto]=<radio_cand-(radio_cand*cnt_pto/puntos)+radio_cand*.5*rand(r_cand),alto_cand*cnt_pto/puntos,0>;
  #declare cnt_pto=cnt_pto+1;
 #end
 #declare a_surt2[puntos-2]=<0,alto_cand,0>;
 #declare a_surt2[puntos-1]=<0,alto_cand,0>;
 object{meshlathe(a_surt2,.3,9)
  texture{t_bs_ceram}
  translate 33.1*y
 }
 sphere{
  <0,0,0>,1
  texture{t_bs_ceram}
  translate (38.5+1)*y
 }
 // grille
 union{
  intersection{
   difference{
    superellipsoid{
     <.1,.1>
     scale <10,1,8>
    }
    superellipsoid{
     <.1,.1>
     scale <10,1,8>
     scale .98
    }
   }
   plane{y,0}
   texture{t_bs_ceram}
   translate .5*y
  }
  height_field{
   gif "hf_reja"
   water_level .01
   translate -.5
   scale <20,1,16>
   scale .97
   texture{t_cromo}
  }
  translate 15*z
 }
 // spigot
 union{
  cylinder{
   <0,27.5,0>
   <0,27.5,10>
   .5
   texture{t_bs_metal}
  }
  sphere{
   <0,0,0>,1
   translate <0,27.5,10>
   texture{t_bs_metal}
  }
  cylinder{
   <0,27.5,10>
   <0,24.5,12>
   .5
   texture{t_bs_metal}
  }
  cylinder{
   <0,27.5,10>
   <0,29.5,10>
   .5
   texture{t_bs_metal}
  }
  cone{
   <0,29.5,10>,.6
   <0,32.5,10>,1
   texture{t_bs_ceram}
  }
  translate 2*z
 }
 // bier trademark label
 height_field{
  gif "hf_tapl"
  water_level 0.01
  texture{
   material_map{
    gif "mm_tapl"
    texture{pigment{Clear}}
    texture{Gold_Texture}
    texture{pigment{Firebrick} finish{Metal}}
    texture{pigment{DarkGreen} finish{Metal}}
    texture{t_cromo}
   }
   rotate 90*x
  }
  translate -.5
  rotate -90*x
  scale <10,7.5,.5>
  translate <0,25.75+3,-5.2>
 }
}
